<%
  const splitPropName = propName ? propName.split(".") : []
  const pathItems = propIn === "path" || propIn === "query" ? [propIn, ...splitPropName] : splitPropName

  // 配列の場合は[0]を代表してテストする
  const dataPath = pathItems.map(_ => _ === "{n}" ? "[0]" : `.${_}`).join("")
  const schemaPath = "#" + pathItems.map(_ => _ === "{n}" ? "/items" : `/properties/${_}`).join("")
  const targetPropName = splitPropName.map(_ => _ === "{n}" ? "0" : _).join(".")
-%>
describe('<%- propIn %> <%- propName %> validation', () => {
<% if (schema.type && !(propIn !== "body" && schema.type === "string")) {
  // path, queryの場合、stringのタイプエラーは表現できない
-%>
  it('<%- propIn %> <%- propName %> is <%- schema.type %>', async () => {
    let response

    // Success
    response = await <%- generateRequestCode() %>
    expect(response.status).toBe(200)

    // Validation Error (<%- propName %> is not array)
    response = await <%- generateRequestCode(propIn, targetPropName, schema.type === "string" ? 1 : "a") %>
    expect(response.status).toBe(400)
    expect(response.body).toEqual({
      message: 'Validation Error',
      errors: [
        {
          dataPath: '<%- dataPath %>',
          keyword: 'type',
          message: 'should be <%- schema.type %>',
          params: {
            type: '<%- schema.type %>'
          },
          schemaPath: '<%- schemaPath %>/type'
        }<% if (schema.enum !== undefined) { %>,
        {
          dataPath: '<%- dataPath %>',
          keyword: 'enum',
          message: 'should be equal to one of the allowed values',
          params: {
            allowedValues: [<%- schema.enum.map(v => schema.type === "string" ? `'${v}'` : v).join(", ") %>]
          },
          schemaPath: '<%- schemaPath %>/enum'
        }<% } %>
      ]
    })
  })
<% } -%>
<% if (propRequired === true) {
  const parentPathItems = pathItems.slice(0, - 1)
  const parentDataPath = parentPathItems.map(_ => _ === "{n}" ? "[0]" : `.${_}`).join("")
  const parentSchemaPath = "#" + parentPathItems.map(_ => _ === "{n}" ? "/items" : `/properties/${_}`).join("")
  const propNameForRequired = pathItems[pathItems.length - 1] // 理由はわからないが、requiredのバリデーションだけ他と異なる
-%>
  it('<%- propIn %> <%- propName %> is required', async () => {
    let response

    // Success
    response = await <%- generateRequestCode() %>
    expect(response.status).toBe(200)

    // Validation Error (<%- propName %> is not object)
    response = await <%- generateRequestCode(propIn, targetPropName, undefined) %>
    expect(response.status).toBe(400)
    expect(response.body).toEqual({
      message: 'Validation Error',
      errors: [
        {
          dataPath: '<%- parentDataPath %>',
          keyword: 'required',
          message: "should have required property '<%- propNameForRequired %>'",
          params: {
            missingProperty: '<%- propNameForRequired %>'
          },
          schemaPath: '<%- parentSchemaPath %>/required'
        }
      ]
    })
  })
<% } -%>
<% if (propRequired === false) {
-%>
  it('<%- propIn %> <%- propName %> is not required', async () => {
    // Success
    const response = await <%- generateRequestCode(propIn, targetPropName, undefined) %>
    expect(response.status).toBe(200)
  })
<% } -%>
<% if (propIn === "body" && schema.nullable) {
  // path, queryの場合、nullableは表現できない
-%>
  it('<%- propIn %> <%- propName %> is nullable', async () => {
    // Success
    const response = await <%- generateRequestCode(propIn, targetPropName, null) %>
    expect(response.status).toBe(200)
  })
<% } -%>
<% if (propIn === "body" && !schema.nullable) {　
  // path, queryの場合、nullableは表現できない
-%>
  it('<%- propIn %> <%- propName %> is not null', async () => {
    // Success
    const response = await <%- generateRequestCode(propIn, targetPropName, null) %>
    expect(response.status).toBe(400)
    expect(response.body).toEqual({
      message: 'Validation Error',
      errors: [
        {
          dataPath: '<%- dataPath %>',
          keyword: 'type',
          message: 'should be <%- schema.type %>',
          params: {
            type: '<%- schema.type %>'
          },
          schemaPath: '<%- schemaPath %>/type'
        }
      ]
    })
  })
<% } -%>
<% if (schema.type === "integer" && schema.enum !== undefined) {
  let invalidVal = 0
  while (schema.enum.includes(invalidVal)) {
    invalidVal++
  }
-%>
  it('<%- propIn %> <%- propName %> not in enum', async () => {
    let response

    // Success
<% for (const validVal of schema.enum) { -%>
    response = await <%- generateRequestCode(propIn, targetPropName, validVal) %>
    expect(response.status).toBe(200)

<% } -%>
    // Validation Error (<%- propName %> not in enum)
    response = await <%- generateRequestCode(propIn, targetPropName, invalidVal) %>
    expect(response.status).toBe(400)
    expect(response.body).toEqual({
      message: 'Validation Error',
      errors: [
        {
          dataPath: '<%- dataPath %>',
          keyword: 'enum',
          message: 'should be equal to one of the allowed values',
          params: {
            allowedValues: [<%- schema.enum.join(", ") %>]
          },
          schemaPath: '<%- schemaPath %>/enum'
        }
      ]
    })
  })

<% } -%>
<% if (schema.type === "integer" && schema.minimum !== undefined) { -%>
  it('<%- propIn %> <%- propName %> minimum', async () => {
    let response

    // Success
    response = await <%- generateRequestCode(propIn, targetPropName, schema.minimum) %>
    expect(response.status).toBe(200)

    // Validation Error (<%- propName %> invalid minimum)
    response = await <%- generateRequestCode(propIn, targetPropName, schema.minimum - 1) %>
    expect(response.status).toBe(400)
    expect(response.body).toEqual({
      message: 'Validation Error',
      errors: [
        {
          dataPath: '<%- dataPath %>',
          keyword: 'minimum',
          message: 'should be >= <%- schema.minimum %>',
          params: {
            comparison: '>=',
            exclusive: false,
            limit: <%- schema.minimum %>
          },
          schemaPath: '<%- schemaPath %>/minimum'
        }
      ]
    })
  })
<% } -%>
<% if (schema.type === "integer" && schema.maximum !== undefined) { -%>
  it('<%- propIn %> <%- propName %> maximum', async () => {
    let response

    // Success
    response = await <%- generateRequestCode(propIn, targetPropName, schema.maximum) %>
    expect(response.status).toBe(200)

    // Validation Error (<%- propName %> invalid maximum)
    response = await <%- generateRequestCode(propIn, targetPropName, schema.maximum + 1) %>
    expect(response.status).toBe(400)
    expect(response.body).toEqual({
      message: 'Validation Error',
      errors: [
        {
          dataPath: '<%- dataPath %>',
          keyword: 'maximum',
          message: 'should be <= <%- schema.maximum %>',
          params: {
            comparison: '<=',
            exclusive: false,
            limit: <%- schema.maximum %>
          },
          schemaPath: '<%- schemaPath %>/maximum'
        }
      ]
    })
  })
<% } -%>
<% if (schema.type === "string" && schema.format === "uuid") { -%>
  it('<%- propIn %> <%- propName %> is uuid', async () => {
    let response

    // Success
    response = await <%- generateRequestCode(propIn, targetPropName, '550e8400-e29b-41d4-a716-446655440000') %>
    expect(response.status).toBe(200)

    // Validation Error (<%- propName %> is not uuid)
    response = await <%- generateRequestCode(propIn, targetPropName, '550e8400-e29b-41d4-a716-446655440000a') %>
    expect(response.status).toBe(400)
    expect(response.body).toEqual({
      message: 'Validation Error',
      errors: [
        {
          dataPath: '<%- dataPath %>',
          keyword: 'format',
          message: 'should match format "uuid"',
          params: {
            format: 'uuid'
          },
          schemaPath: '<%- schemaPath %>/format'
        }
      ]
    })
  })
<% } -%>
<% if (schema.type === "string" && schema.minLength !== undefined && (schema.format !== "uri" || 9 <= schema.minLength)) {
  // formatがuriの場合、"https://"を含めないとformatエラーになってしまう。
  // formatエラーも考慮してテストを書く事もできるが、テンプレートが複雑になってしまうため、maxLengthが9以上であるときのみテストケースを出力する。
  -%>
  it('<%- propIn %> <%- propName %> min length', async () => {
    let response

    // Success
<% if (schema.format === "uri") { -%>
    response = await <%- generateRequestCode(propIn, targetPropName, () => `'https://' + 'a'.repeat(${schema.minLength} - 8)`) %>
<% } else { -%>
    response = await <%- generateRequestCode(propIn, targetPropName, () => `'a'.repeat(${schema.minLength})`) %>
<% } -%>
    expect(response.status).toBe(200)

    // Validation Error (<%- propName %> is invalid length)
<% if (schema.format === "uri") { -%>
    response = await <%- generateRequestCode(propIn, targetPropName, () => `'https://' + 'a'.repeat(${schema.minLength - 1} - 8)`) %>
<% } else { -%>
    response = await <%- generateRequestCode(propIn, targetPropName, () => `'a'.repeat(${schema.minLength - 1})`) %>
<% } -%>
    expect(response.status).toBe(400)
    expect(response.body).toEqual({
      message: 'Validation Error',
      errors: [
        {
          dataPath: '<%- dataPath %>',
          keyword: 'minLength',
          message: 'should NOT be shorter than <%- schema.minLength %> characters',
          params: {
            limit: <%- schema.minLength %>
          },
          schemaPath: '<%- schemaPath %>/minLength'
        }
      ]
    })
  })
<% } -%>
<%　if (schema.type === "string" && schema.maxLength !== undefined && (schema.format !== "uri" || 8 <= schema.maxLength)) {　
  // formatがuriの場合、"https://"を含めないとformatエラーになってしまう。
  // formatエラーも考慮してテストを書く事もできるが、テンプレートが複雑になってしまうため、maxLengthが8以上であるときのみテストケースを出力する。
-%>
  it('<%- propIn %> <%- propName %> max length', async () => {
    let response

    // Success
<% if (schema.format === "uri") { -%>
    response = await <%- generateRequestCode(propIn, targetPropName, () => `'https://' + 'a'.repeat(${schema.maxLength} - 8)`) %>
<% } else { -%>
    response = await <%- generateRequestCode(propIn, targetPropName, () => `'a'.repeat(${schema.maxLength})`) %>
<% } -%>
    expect(response.status).toBe(200)

    // Validation Error (<%- propName %> is invalid length)
<% if (schema.format === "uri") { -%>
    response = await <%- generateRequestCode(propIn, targetPropName, () => `'https://' + 'a'.repeat(${schema.maxLength + 1} - 8)`) %>
<% } else { -%>
    response = await <%- generateRequestCode(propIn, targetPropName, () => `'a'.repeat(${schema.maxLength + 1})`) %>
<% } -%>
    expect(response.status).toBe(400)
    expect(response.body).toEqual({
      message: 'Validation Error',
      errors: [
        {
          dataPath: '<%- dataPath %>',
          keyword: 'maxLength',
          message: 'should NOT be longer than <%- schema.maxLength %> characters',
          params: {
            limit: <%- schema.maxLength %>
          },
          schemaPath: '<%- schemaPath %>/maxLength'
        }
      ]
    })
  })
<% } -%>
<% if (schema.type === "string" && schema.enum !== undefined) { -%>
  it('<%- propIn %> <%- propName %> not in enum', async () => {
    let response

    // Success
<% for (const validVal of schema.enum) { -%>
    response = await <%- generateRequestCode(propIn, targetPropName, validVal) %>
    expect(response.status).toBe(200)

<% } -%>
    // Validation Error (<%- propName %> not in enum)
    response = await <%- generateRequestCode(propIn, targetPropName, "INVALID") %>
    expect(response.status).toBe(400)
    expect(response.body).toEqual({
      message: 'Validation Error',
      errors: [
        {
          dataPath: '<%- dataPath %>',
          keyword: 'enum',
          message: 'should be equal to one of the allowed values',
          params: {
            allowedValues: [<%- schema.enum.map(_ => `'${_}'`).join(", ") %>]
          },
          schemaPath: '<%- schemaPath %>/enum'
        }
      ]
    })
  })
<% } -%>
})
